Index: issm/branches/trunk-jpl-damage/src/c/modules/Shp2Kmlx/Shp2Kmlx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Shp2Kmlx/Shp2Kmlx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Shp2Kmlx/Shp2Kmlx.cpp	(revision 12878)
@@ -39,7 +39,7 @@
 	int     nshape,ncoord;
 	double  cpsum;
-	int     *pstype=NULL,*pnpart=NULL,**ppstrt=NULL,**pptype=NULL,*pnvert=NULL;
-	double  **pshapx=NULL,**pshapy=NULL,**pshapz=NULL,**pshapm=NULL;
-	double  *lat=NULL,*lon=NULL;
+	int     *pstype = NULL, *pnpart=NULL,**ppstrt=NULL,**pptype=NULL,*pnvert=NULL;
+	double **pshapx = NULL,**pshapy=NULL,**pshapz=NULL,**pshapm=NULL;
+	double  *lat    = NULL, *lon=NULL;
 
 	SHPHandle   hSHP;
@@ -49,18 +49,17 @@
 
 	char    indent[81]="";
-	KML_File*             kfile =NULL;
-	KML_Document*         kdoc  =NULL;
-	KML_Style*            kstyle=NULL;
-	KML_LineStyle*        klsty =NULL;
-	KML_PolyStyle*        kpsty =NULL;
-	KML_Folder*           kfold =NULL;
-	KML_Placemark*        kplace=NULL;
-	KML_MultiGeometry*    kmulti=NULL;
-	KML_Polygon*          kpoly =NULL;
-	KML_LinearRing*       kring =NULL;
-	KML_LineString*       kline =NULL;
-	KML_Point*            kpoint=NULL;
-
-	FILE*   fid=NULL;
+	KML_File          *kfile  = NULL;
+	KML_Document      *kdoc   = NULL;
+	KML_Style         *kstyle = NULL;
+	KML_LineStyle     *klsty  = NULL;
+	KML_PolyStyle     *kpsty  = NULL;
+	KML_Folder        *kfold  = NULL;
+	KML_Placemark     *kplace = NULL;
+	KML_MultiGeometry *kmulti = NULL;
+	KML_Polygon       *kpoly  = NULL;
+	KML_LinearRing    *kring  = NULL;
+	KML_LineString    *kline  = NULL;
+	KML_Point         *kpoint = NULL;
+	FILE              *fid    = NULL;
 
 	clock_t clock0,clock1;
@@ -69,5 +68,5 @@
 	clock0=clock();
 	time0 =time(NULL);
-	_printf_(true,"\nShp2Kmlx Module -- %s",ctime(&time0));
+	_pprintString_("\nShp2Kmlx Module -- " << ctime(&time0));
 
 /*  note that much of the following code is taken from shpdump.c in shapelib.  */
@@ -76,5 +75,5 @@
 
 	hSHP = SHPOpen( filshp, "rb" );
-	if (!hSHP) _error_("Error opening shp/shx files.");
+	if (!hSHP) _error2_("Error opening shp/shx files.");
 
 /*  read header and print out file bounds  */
@@ -97,13 +96,13 @@
 
 	nshape=nEntities;
-	pstype=(int *) xmalloc(nshape*sizeof(int));
-	pnpart=(int *) xmalloc(nshape*sizeof(int));
-	ppstrt=(int **) xmalloc(nshape*sizeof(int *));
-	pptype=(int **) xmalloc(nshape*sizeof(int *));
-	pnvert=(int *) xmalloc(nshape*sizeof(int));
-	pshapx=(double **) xmalloc(nshape*sizeof(double *));
-	pshapy=(double **) xmalloc(nshape*sizeof(double *));
-	pshapz=(double **) xmalloc(nshape*sizeof(double *));
-	pshapm=(double **) xmalloc(nshape*sizeof(double *));
+	pstype=xNew<int>(nshape);
+	pnpart=xNew<int>(nshape);
+	ppstrt=xNew<int*>(nshape);
+	pptype=xNew<int*>(nshape);
+	pnvert=xNew<int>(nshape);
+	pshapx=xNew<double*>(nshape);
+	pshapy=xNew<double*>(nshape);
+	pshapz=xNew<double*>(nshape);
+	pshapm=xNew<double*>(nshape);
 
 /*  loop over the list of shapes  */
@@ -129,6 +128,6 @@
 	pnpart[i]=psShape->nParts;
 	if (pnpart[i]) {
-		ppstrt[i]=(int *) xmalloc(pnpart[i]*sizeof(int));
-		pptype[i]=(int *) xmalloc(pnpart[i]*sizeof(int));
+		ppstrt[i]=xNew<int>(pnpart[i]);
+		pptype[i]=xNew<int>(pnpart[i]);
 	}
 	else {
@@ -138,8 +137,8 @@
 	pnvert[i]=psShape->nVertices;
 	if (pnvert[i]) {
-		pshapx[i]=(double *) xmalloc(pnvert[i]*sizeof(double));
-		pshapy[i]=(double *) xmalloc(pnvert[i]*sizeof(double));
-		pshapz[i]=(double *) xmalloc(pnvert[i]*sizeof(double));
-		pshapm[i]=(double *) xmalloc(pnvert[i]*sizeof(double));
+		pshapx[i]=xNew<double>(pnvert[i]);
+		pshapy[i]=xNew<double>(pnvert[i]);
+		pshapz[i]=xNew<double>(pnvert[i]);
+		pshapm[i]=xNew<double>(pnvert[i]);
 	}
 	else {
@@ -296,6 +295,6 @@
 			kpoint=new KML_Point();
 
-			lat=(double *) xmalloc(pnvert[i]*sizeof(double));
-			lon=(double *) xmalloc(pnvert[i]*sizeof(double));
+			lat=xNew<double>(pnvert[i]);
+			lon=xNew<double>(pnvert[i]);
 			if (sgn) {
 				Xy2llx(lat,lon,pshapx[i],pshapy[i],pnvert[i],sgn,cm,sp);
@@ -310,6 +309,6 @@
 			kpoint->coords[2]=pshapz[i][0];
 
-			xfree((void**)&lon);
-			xfree((void**)&lat);
+			xDelete<double>(lon);
+			xDelete<double>(lat);
 
 			(kplace->geometry  )->AddObject((Object*)kpoint);
@@ -337,6 +336,6 @@
 /*  convert to lat/lon, if necessary  */
 
-			lat=(double *) xmalloc(pnvert[i]*sizeof(double));
-			lon=(double *) xmalloc(pnvert[i]*sizeof(double));
+			lat=xNew<double>(pnvert[i]);
+			lon=xNew<double>(pnvert[i]);
 			if (sgn) {
 				Xy2llx(lat,lon,pshapx[i],pshapy[i],pnvert[i],sgn,cm,sp);
@@ -353,21 +352,20 @@
 
 				kline->ncoord    =(j<pnpart[i]-1 ? ppstrt[i][j+1]-ppstrt[i][j] : pnvert[i]-ppstrt[i][j]);
-				kline->coords    =(double (*)[3]) xmalloc(kline->ncoord*3*sizeof(double));
+				kline->coords    =xNew<double>(kline->ncoord*3);
 				for (k=0; k<kline->ncoord; k++) {
-					kline->coords[k][0]=lon      [ppstrt[i][j]+k];
-					kline->coords[k][1]=lat      [ppstrt[i][j]+k];
-					kline->coords[k][2]=pshapz[i][ppstrt[i][j]+k];
+					kline->coords[3*k+0]=lon      [ppstrt[i][j]+k];
+					kline->coords[3*k+1]=lat      [ppstrt[i][j]+k];
+					kline->coords[3*k+2]=pshapz[i][ppstrt[i][j]+k];
 				}
-
 				(kmulti->geometry  )->AddObject((Object*)kline);
-				kline =NULL;
-			}
-
-			xfree((void**)&lon);
-			xfree((void**)&lat);
-
-			(kplace->geometry  )->AddObject((Object*)kmulti);
+				kline = NULL;
+			}
+
+			xDelete<double>(lon);
+			xDelete<double>(lat);
+
+			(kplace->geometry)->AddObject((Object*)kmulti);
 			kmulti=NULL;
-			(kfold ->feature   )->AddObject((Object*)kplace);
+			(kfold ->feature )->AddObject((Object*)kplace);
 			kplace=NULL;
 		}
@@ -401,6 +399,6 @@
 /*  convert to lat/lon, if necessary  */
 
-			lat=(double *) xmalloc(pnvert[i]*sizeof(double));
-			lon=(double *) xmalloc(pnvert[i]*sizeof(double));
+			lat=xNew<double>(pnvert[i]);
+			lon=xNew<double>(pnvert[i]);
 			if (sgn) {
 				Xy2llx(lat,lon,pshapx[i],pshapy[i],pnvert[i],sgn,cm,sp);
@@ -438,16 +436,16 @@
 
 					kring->ncoord    =(j<pnpart[i]-1 ? ppstrt[i][j+1]-ppstrt[i][j] : pnvert[i]-ppstrt[i][j]);
-					kring->coords    =(double (*)[3]) xmalloc(kring->ncoord*3*sizeof(double));
+					kring->coords    =xNew<double>(kring->ncoord*3);
 					if (cpsum < 0)
 						for (k=0; k<kring->ncoord; k++) {
-							kring->coords[kring->ncoord-1-k][0]=lon      [ppstrt[i][j]+k];
-							kring->coords[kring->ncoord-1-k][1]=lat      [ppstrt[i][j]+k];
-							kring->coords[kring->ncoord-1-k][2]=pshapz[i][ppstrt[i][j]+k];
+							kring->coords[3*(kring->ncoord-1-k)+0]=lon      [ppstrt[i][j]+k];
+							kring->coords[3*(kring->ncoord-1-k)+1]=lat      [ppstrt[i][j]+k];
+							kring->coords[3*(kring->ncoord-1-k)+2]=pshapz[i][ppstrt[i][j]+k];
 						}
 					else
 						for (k=0; k<kring->ncoord; k++) {
-							kring->coords[k                ][0]=lon      [ppstrt[i][j]+k];
-							kring->coords[k                ][1]=lat      [ppstrt[i][j]+k];
-							kring->coords[k                ][2]=pshapz[i][ppstrt[i][j]+k];
+							kring->coords[3*k+0]=lon      [ppstrt[i][j]+k];
+							kring->coords[3*k+1]=lat      [ppstrt[i][j]+k];
+							kring->coords[3*k+2]=pshapz[i][ppstrt[i][j]+k];
 						}
 
@@ -470,9 +468,9 @@
 
 					kring->ncoord    =(j<pnpart[i]-1 ? ppstrt[i][j+1]-ppstrt[i][j] : pnvert[i]-ppstrt[i][j]);
-					kring->coords    =(double (*)[3]) xmalloc(kring->ncoord*3*sizeof(double));
+					kring->coords    =xNew<double>(kring->ncoord*3);
 					for (k=0; k<kring->ncoord; k++) {
-						kring->coords[k][0]=lon      [ppstrt[i][j]+k];
-						kring->coords[k][1]=lat      [ppstrt[i][j]+k];
-						kring->coords[k][2]=pshapz[i][ppstrt[i][j]+k];
+						kring->coords[3*k+0]=lon      [ppstrt[i][j]+k];
+						kring->coords[3*k+1]=lat      [ppstrt[i][j]+k];
+						kring->coords[3*k+2]=pshapz[i][ppstrt[i][j]+k];
 					}
 
@@ -487,6 +485,6 @@
 			}
 
-			xfree((void**)&lon);
-			xfree((void**)&lat);
+			xDelete<double>(lon);
+			xDelete<double>(lat);
 
 			(kplace->geometry  )->AddObject((Object*)kmulti);
@@ -518,6 +516,6 @@
 /*  convert to lat/lon, if necessary  */
 
-			lat=(double *) xmalloc(pnvert[i]*sizeof(double));
-			lon=(double *) xmalloc(pnvert[i]*sizeof(double));
+			lat=xNew<double>(pnvert[i]);
+			lon=xNew<double>(pnvert[i]);
 			if (sgn) {
 				Xy2llx(lat,lon,pshapx[i],pshapy[i],pnvert[i],sgn,cm,sp);
@@ -541,6 +539,6 @@
 			}
 
-			xfree((void**)&lon);
-			xfree((void**)&lat);
+			xDelete<double>(lon);
+			xDelete<double>(lat);
 
 			(kplace->geometry  )->AddObject((Object*)kmulti);
@@ -575,5 +573,5 @@
 /*  write kml file  */
 
-	_printf_(true,"Writing kml document to file.\n");
+	_pprintLine_("Writing kml document to file.");
 	fid=fopen(filkml,"w");
 	fprintf(fid,"<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n");
@@ -583,22 +581,22 @@
 	delete kfile;
 	for (i=nshape-1; i>=0; i--) {
-		xfree((void**)&(pshapm[i]));
-		xfree((void**)&(pshapz[i]));
-		xfree((void**)&(pshapy[i]));
-		xfree((void**)&(pshapx[i]));
-	}
-	xfree((void**)&pshapm);
-	xfree((void**)&pshapz);
-	xfree((void**)&pshapy);
-	xfree((void**)&pshapx);
-	xfree((void**)&pnvert);
+		xDelete<double>((pshapm[i]));
+		xDelete<double>((pshapz[i]));
+		xDelete<double>((pshapy[i]));
+		xDelete<double>((pshapx[i]));
+	}
+	xDelete<double*>(pshapm);
+	xDelete<double*>(pshapz);
+	xDelete<double*>(pshapy);
+	xDelete<double*>(pshapx);
+	xDelete<int>(pnvert);
 	for (i=nshape-1; i>=0; i--) {
-		xfree((void**)&(pptype[i]));
-		xfree((void**)&(ppstrt[i]));
-	}
-	xfree((void**)&pptype);
-	xfree((void**)&ppstrt);
-	xfree((void**)&pnpart);
-	xfree((void**)&pstype);
+		xDelete<int>((pptype[i]));
+		xDelete<int>((ppstrt[i]));
+	}
+	xDelete<int*>(pptype);
+	xDelete<int*>(ppstrt);
+	xDelete<int>(pnpart);
+	xDelete<int>(pstype);
 
 	clock1=clock();
Index: issm/branches/trunk-jpl-damage/src/c/modules/Shp2Kmlx/Shp2Kmlx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Shp2Kmlx/Shp2Kmlx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Shp2Kmlx/Shp2Kmlx.h	(revision 12878)
@@ -19,5 +19,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/SmbGradientsx/SmbGradientsx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/SmbGradientsx/SmbGradientsx.cpp	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/modules/SmbGradientsx/SmbGradientsx.cpp	(revision 12878)
@@ -0,0 +1,27 @@
+/*!\file SmbGradientsx
+ * \brief: calculates SMB as function of local elevation 
+ */
+
+#include "./SmbGradientsx.h"
+#include "../../shared/shared.h"
+#include "../../include/include.h"
+#include "../../io/io.h"
+#include "../../toolkits/toolkits.h"
+#include "../../EnumDefinitions/EnumDefinitions.h"
+
+void SmbGradientsx(Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads,Materials* materials, Parameters* parameters){
+
+// void SmbGradientsx(hd,agd,ni){
+//    INPUT parameters: ni: working size of arrays
+//    INPUT: surface elevation (m): hd(NA)
+//    OUTPUT: mass-balance (m/yr ice): agd(NA)
+
+  int    i;
+  
+  Element* element = NULL;
+  
+  for(i=0;i<elements->Size();i++){
+    element=(Element*)elements->GetObjectByOffset(i);
+    element->SmbGradients();
+  }
+}
Index: issm/branches/trunk-jpl-damage/src/c/modules/SmbGradientsx/SmbGradientsx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/SmbGradientsx/SmbGradientsx.h	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/modules/SmbGradientsx/SmbGradientsx.h	(revision 12878)
@@ -0,0 +1,14 @@
+/*!\file:  SmbGradientsx.h
+ * \brief header file for degree of freedoms distribution routines.
+ */ 
+
+#ifndef _SMBGRADIENTSX_H
+#define _SMBGRADIENTSX_H
+
+#include "../../Container/Container.h"
+#include "../../classes/objects/objects.h"
+
+/* local prototypes: */
+void SmbGradientsx(Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads,Materials* materials, Parameters* parameters);
+
+#endif  /* _SMBGRADIENTSX_H*/
Index: issm/branches/trunk-jpl-damage/src/c/modules/SmearFunctionx/SmearFunctionx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/SmearFunctionx/SmearFunctionx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/SmearFunctionx/SmearFunctionx.h	(revision 12878)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/Solverx/DofTypesToIndexSet.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Solverx/DofTypesToIndexSet.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Solverx/DofTypesToIndexSet.cpp	(revision 12878)
@@ -20,5 +20,5 @@
 
 	int         start,end;
-	double*     df_local=NULL;
+	IssmDouble*     df_local=NULL;
 	int         df_local_size;
 	int         i;
@@ -46,6 +46,6 @@
 
 		/*Allocate indices: */
-		if(pressure_num)pressure_indices=(int*)xmalloc(pressure_num*sizeof(int));
-		if(velocity_num)velocity_indices=(int*)xmalloc(velocity_num*sizeof(int));
+		if(pressure_num)pressure_indices=xNew<int>(pressure_num);
+		if(velocity_num)velocity_indices=xNew<int>(velocity_num);
 
 		pressure_count=0;
@@ -74,6 +74,6 @@
 
 	/*Free ressources:*/
-	xfree((void**)&pressure_indices);
-	xfree((void**)&velocity_indices);
+	xDelete<int>(pressure_indices);
+	xDelete<int>(velocity_indices);
 
 	/*Assign output pointers:*/
Index: issm/branches/trunk-jpl-damage/src/c/modules/Solverx/Solverx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Solverx/Solverx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Solverx/Solverx.cpp	(revision 12878)
@@ -26,36 +26,20 @@
 	_assert_(pf);
 
-	#ifdef _HAVE_PETSC_
-		Vec uf0_vector = NULL;
-		Vec df_vector  = NULL;
-		Vec uf_vector  = NULL;
-		if(uf0) uf0_vector = uf0->vector;
-		if(df)  df_vector  = df->vector;
+	/*Initialize vector: */
+	uf=new Vector();
 
-		/*In serial mode, the Petsc Options database has not been initialized properly: */
+	/*According to matrix type, use specific solvers: */
+	if(Kff->type==PetscMatType){
+		PetscVec* uf0_vector = NULL;
+		PetscVec* df_vector  = NULL;
+		if(uf0) uf0_vector = uf0->pvector;
+		if(df)  df_vector  = df->pvector;
 
-		SolverxPetsc(&uf_vector,Kff->matrix,pf->vector,uf0_vector,df_vector,parameters);
-
-		/*Create vector out of petsc vector: */
-		uf=new Vector(uf_vector);
-
-		/*Free ressources: */
-		VecFree(&uf_vector);
-	#else
-		#ifdef _HAVE_GSL_
-		SeqVec* uf_vector=NULL;
-
-		SolverxGsl(&uf_vector,Kff->matrix,pf->vector);
-
-		/*Create vector out of SeqVec vector: */
-		uf=new Vector(uf_vector);
-
-		/*Free ressources: */
-		delete uf_vector;
-
-		#else
-			_error_("GSL support not compiled in!");
-		#endif
-	#endif
+		SolverxPetsc(&uf->pvector,Kff->pmatrix,pf->pvector,uf0_vector,df_vector,parameters);
+	}
+	else if(Kff->type==SeqMatType){
+		SolverxSeq(&uf->svector,Kff->smatrix,pf->svector);
+	}
+	else _error2_("Matrix type: " << Kff->type << " not supported yet!");
 
 	/*Assign output pointers:*/
Index: issm/branches/trunk-jpl-damage/src/c/modules/Solverx/Solverx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Solverx/Solverx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Solverx/Solverx.h	(revision 12878)
@@ -12,5 +12,5 @@
 #endif
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
@@ -18,11 +18,11 @@
 
 #ifdef _HAVE_PETSC_
+void	SolverxPetsc(PetscVec** puf, PetscMat* Kff, PetscVec* pf, PetscVec* uf0,PetscVec* df, Parameters* parameters);
 void	SolverxPetsc(Vec* puf, Mat Kff, Vec pf, Vec uf0,Vec df, Parameters* parameters);
-void    DofTypesToIndexSet(IS* pisv, IS* pisp, Vec df,int typeenum);
+void  DofTypesToIndexSet(IS* pisv, IS* pisp, Vec df,int typeenum);
 #endif
 
-#ifdef _HAVE_GSL_
-void	SolverxGsl(SeqVec** puf,SeqMat* Kff, SeqVec* pf);
-#endif
+void SolverxSeq(SeqVec** puf,SeqMat* Kff, SeqVec* pf);
+void SolverxSeq(IssmDouble** pX,IssmDouble* A,IssmDouble* B,int n);
 
 #endif  /* _SOLVERX_H */
Index: issm/branches/trunk-jpl-damage/src/c/modules/Solverx/SolverxPetsc.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Solverx/SolverxPetsc.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Solverx/SolverxPetsc.cpp	(revision 12878)
@@ -14,4 +14,19 @@
 #endif
 
+void	SolverxPetsc(PetscVec** puf, PetscMat* Kff, PetscVec* pf, PetscVec* uf0,PetscVec* df, Parameters* parameters){
+
+	PetscVec* uf=new PetscVec();
+
+	Vec uf0_vector = NULL;
+	Vec df_vector  = NULL;
+	
+	if(uf0) uf0_vector = uf0->vector;
+	if(df)  df_vector  = df->vector;
+
+	SolverxPetsc(&uf->vector, Kff->matrix, pf->vector, uf0_vector, df_vector, parameters);
+
+	*puf=uf;
+
+}
 void	SolverxPetsc(Vec* puf, Mat Kff, Vec pf, Vec uf0,Vec df, Parameters* parameters){
 
@@ -44,5 +59,5 @@
 
 	/*Display message*/
-	_printf_(VerboseModule(),"   Solving\n");
+	if(VerboseModule()) _pprintLine_("   Solving");
 	#if _PETSC_MAJOR_ < 3 || (_PETSC_MAJOR_ == 3 && _PETSC_MINOR_ < 2)
 	if(VerboseSolver())PetscOptionsPrint(stdout);
@@ -55,5 +70,5 @@
 	MatGetSize(Kff,&global_m,&global_n); _assert_(global_m==global_m);
 	if(!global_n){
-		*puf=NULL; return;
+		*puf=NewVec(0); return;
 	}
 
@@ -81,5 +96,5 @@
 		#if _PETSC_MAJOR_ >=3
 			#ifndef _HAVE_MUMPS_
-			_error_("requested MUMPS solver, which was not compiled into ISSM!\n");
+			_error2_("requested MUMPS solver, which was not compiled into ISSM!\n");
 			#endif
 		#endif
@@ -105,5 +120,5 @@
 	if (solver_type==StokesSolverEnum){
 		/*Make indices out of doftypes: */
-		if(!df)_error_("need doftypes for Stokes solver!\n");
+		if(!df)_error2_("need doftypes for Stokes solver!\n");
 		DofTypesToIndexSet(&isv,&isp,df,StokesSolverEnum);
 
@@ -136,5 +151,5 @@
 	/*Check convergence*/
 	KSPGetIterationNumber(ksp,&iteration_number);
-	if (iteration_number<0) _error_("%s%i"," Solver diverged at iteration number: ",-iteration_number);
+	if (iteration_number<0) _error2_("Solver diverged at iteration number: " << -iteration_number);
 
 	/*Free resources:*/
Index: issm/branches/trunk-jpl-damage/src/c/modules/Solverx/SolverxSeq.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Solverx/SolverxSeq.cpp	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Solverx/SolverxSeq.cpp	(revision 12878)
@@ -0,0 +1,89 @@
+/*!\file SolverxSeq
+ * \brief implementation of sequential solver using the GSL librarie
+ */
+
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+#include <cstring>
+
+#include "./Solverx.h"
+#include "../../shared/shared.h"
+#include "../../include/include.h"
+#include "../../io/io.h"
+
+#ifdef _HAVE_GSL_
+#include <gsl/gsl_linalg.h>
+#endif
+
+void SolverxSeq(SeqVec** puf,SeqMat* Kff, SeqVec* pf){/*{{{*/
+
+	#ifdef _HAVE_GSL_
+	/*Intermediary: */
+	int M,N,N2,s;
+	SeqVec *uf = NULL;
+	IssmDouble *x  = NULL;
+
+	Kff->GetSize(&M,&N);
+	pf->GetSize(&N2);
+
+	if(N!=N2)_error2_("Right hand side vector of size " << N2 << ", when matrix is of size " << M << "-" << N << " !");
+	if(M!=N)_error2_("Stiffness matrix should be square!");
+
+	SolverxSeq(&x,Kff->matrix,pf->vector,N);
+	uf=new SeqVec(x,N);
+
+	/*Assign output pointers:*/
+	*puf=uf;
+
+	#else
+		_error2_("GSL support not compiled in!");
+	#endif
+
+}/*}}}*/
+void SolverxSeq(IssmDouble** pX,IssmDouble* A,IssmDouble* B,int n){/*{{{*/
+
+	#ifdef _HAVE_GSL_
+		/*GSL Matrices and vectors: */
+		int              s;
+		gsl_matrix_view  a;
+		gsl_vector_view  b;
+		gsl_vector      *x = NULL;
+		gsl_permutation *p = NULL;
+		#ifdef _HAVE_ADOLC_
+			// if we use Adol-C then the IssmDouble will be an adouble
+			// and the calls to gsl_... will not work
+			// and we should call  a suitable wrapped solve instead
+			_error2_("SolverxSeq: should not be here with Adol-C");
+		#else
+			/*A will be modified by LU decomposition. Use copy*/
+			IssmDouble* Acopy = xNew<IssmDouble>(n*n);
+			xMemCpy<IssmDouble>(Acopy,A,n*n);
+
+			/*Initialize gsl matrices and vectors: */
+			a = gsl_matrix_view_array (Acopy,n,n);
+			b = gsl_vector_view_array (B,n);
+			x = gsl_vector_alloc (n);
+
+			/*Run LU and solve: */
+			p = gsl_permutation_alloc (n);
+			gsl_linalg_LU_decomp (&a.matrix, p, &s);
+			gsl_linalg_LU_solve (&a.matrix, p, &b.vector, x);
+
+			//printf ("x = \n");
+			//gsl_vector_fprintf (stdout, x, "%g");
+
+			/*Copy result*/
+			IssmDouble* X = xNew<IssmDouble>(n);
+			memcpy(X,gsl_vector_ptr(x,0),n*sizeof(IssmDouble));
+
+			/*Clean up and assign output pointer*/
+			xDelete<IssmDouble>(Acopy);
+			gsl_permutation_free(p);
+			gsl_vector_free(x);
+			*pX=X;
+		#endif
+	#endif
+}/*}}}*/
Index: issm/branches/trunk-jpl-damage/src/c/modules/SpcNodesx/SpcNodesx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/SpcNodesx/SpcNodesx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/SpcNodesx/SpcNodesx.h	(revision 12878)
@@ -6,5 +6,5 @@
 #define _SPCNODESX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../Container/Container.h"
 #include "../../toolkits/toolkits.h"
Index: issm/branches/trunk-jpl-damage/src/c/modules/StringToEnumx/StringToEnumx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/StringToEnumx/StringToEnumx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/StringToEnumx/StringToEnumx.cpp	(revision 12878)
@@ -8,4 +8,5 @@
 */
 
+#include <cstring>
 #include "../../shared/shared.h"
 #include "../../include/include.h"
@@ -110,4 +111,5 @@
 	      else if (strcmp(name,"MaterialsRhoIce")==0) return MaterialsRhoIceEnum;
 	      else if (strcmp(name,"MaterialsRhoWater")==0) return MaterialsRhoWaterEnum;
+	      else if (strcmp(name,"MaterialsRhoFreshwater")==0) return MaterialsRhoFreshwaterEnum;
 	      else if (strcmp(name,"MaterialsMuWater")==0) return MaterialsMuWaterEnum;
 	      else if (strcmp(name,"MaterialsThermalExchangeVelocity")==0) return MaterialsThermalExchangeVelocityEnum;
@@ -136,9 +138,9 @@
 	      else if (strcmp(name,"MiscellaneousName")==0) return MiscellaneousNameEnum;
 	      else if (strcmp(name,"PrognosticHydrostaticAdjustment")==0) return PrognosticHydrostaticAdjustmentEnum;
-	      else if (strcmp(name,"PrognosticMinThickness")==0) return PrognosticMinThicknessEnum;
          else stage=2;
    }
    if(stage==2){
-	      if (strcmp(name,"PrognosticPenaltyFactor")==0) return PrognosticPenaltyFactorEnum;
+	      if (strcmp(name,"PrognosticMinThickness")==0) return PrognosticMinThicknessEnum;
+	      else if (strcmp(name,"PrognosticPenaltyFactor")==0) return PrognosticPenaltyFactorEnum;
 	      else if (strcmp(name,"PrognosticSpcthickness")==0) return PrognosticSpcthicknessEnum;
 	      else if (strcmp(name,"PrognosticStabilization")==0) return PrognosticStabilizationEnum;
@@ -158,8 +160,14 @@
 	      else if (strcmp(name,"SettingsResultsAsPatches")==0) return SettingsResultsAsPatchesEnum;
 	      else if (strcmp(name,"SettingsWaitonlock")==0) return SettingsWaitonlockEnum;
-	      else if (strcmp(name,"DebugPetscProfiling")==0) return DebugPetscProfilingEnum;
-	      else if (strcmp(name,"PetscProfilingCurrentMem")==0) return PetscProfilingCurrentMemEnum;
-	      else if (strcmp(name,"PetscProfilingCurrentFlops")==0) return PetscProfilingCurrentFlopsEnum;
-	      else if (strcmp(name,"PetscProfilingSolutionTime")==0) return PetscProfilingSolutionTimeEnum;
+	      else if (strcmp(name,"SurfaceforcingsDelta18o")==0) return SurfaceforcingsDelta18oEnum;
+	      else if (strcmp(name,"SurfaceforcingsDelta18oSurface")==0) return SurfaceforcingsDelta18oSurfaceEnum;
+	      else if (strcmp(name,"SurfaceforcingsIsdelta18o")==0) return SurfaceforcingsIsdelta18oEnum;
+	      else if (strcmp(name,"SurfaceforcingsPrecipitationsPresentday")==0) return SurfaceforcingsPrecipitationsPresentdayEnum;
+	      else if (strcmp(name,"SurfaceforcingsTemperaturesPresentday")==0) return SurfaceforcingsTemperaturesPresentdayEnum;
+	      else if (strcmp(name,"SurfaceforcingsTemperaturesLgm")==0) return SurfaceforcingsTemperaturesLgmEnum;
+	      else if (strcmp(name,"DebugProfiling")==0) return DebugProfilingEnum;
+	      else if (strcmp(name,"ProfilingCurrentMem")==0) return ProfilingCurrentMemEnum;
+	      else if (strcmp(name,"ProfilingCurrentFlops")==0) return ProfilingCurrentFlopsEnum;
+	      else if (strcmp(name,"ProfilingSolutionTime")==0) return ProfilingSolutionTimeEnum;
 	      else if (strcmp(name,"MaxIterationConvergenceFlag")==0) return MaxIterationConvergenceFlagEnum;
 	      else if (strcmp(name,"SteadystateMaxiter")==0) return SteadystateMaxiterEnum;
@@ -170,4 +178,14 @@
 	      else if (strcmp(name,"SurfaceforcingsPrecipitation")==0) return SurfaceforcingsPrecipitationEnum;
 	      else if (strcmp(name,"SurfaceforcingsMassBalance")==0) return SurfaceforcingsMassBalanceEnum;
+	      else if (strcmp(name,"SurfaceforcingsIspdd")==0) return SurfaceforcingsIspddEnum;
+	      else if (strcmp(name,"SurfaceforcingsIssmbgradients")==0) return SurfaceforcingsIssmbgradientsEnum;
+	      else if (strcmp(name,"SurfaceforcingsMonthlytemperatures")==0) return SurfaceforcingsMonthlytemperaturesEnum;
+	      else if (strcmp(name,"SurfaceforcingsHc")==0) return SurfaceforcingsHcEnum;
+	      else if (strcmp(name,"SurfaceforcingsSmbPosMax")==0) return SurfaceforcingsSmbPosMaxEnum;
+	      else if (strcmp(name,"SurfaceforcingsSmbPosMin")==0) return SurfaceforcingsSmbPosMinEnum;
+	      else if (strcmp(name,"SurfaceforcingsAPos")==0) return SurfaceforcingsAPosEnum;
+	      else if (strcmp(name,"SurfaceforcingsBPos")==0) return SurfaceforcingsBPosEnum;
+	      else if (strcmp(name,"SurfaceforcingsANeg")==0) return SurfaceforcingsANegEnum;
+	      else if (strcmp(name,"SurfaceforcingsBNeg")==0) return SurfaceforcingsBNegEnum;
 	      else if (strcmp(name,"ThermalMaxiter")==0) return ThermalMaxiterEnum;
 	      else if (strcmp(name,"ThermalPenaltyFactor")==0) return ThermalPenaltyFactorEnum;
@@ -243,5 +261,8 @@
 	      else if (strcmp(name,"BoolParam")==0) return BoolParamEnum;
 	      else if (strcmp(name,"Contour")==0) return ContourEnum;
-	      else if (strcmp(name,"ControlInput")==0) return ControlInputEnum;
+         else stage=3;
+   }
+   if(stage==3){
+	      if (strcmp(name,"ControlInput")==0) return ControlInputEnum;
 	      else if (strcmp(name,"DatasetInput")==0) return DatasetInputEnum;
 	      else if (strcmp(name,"DofIndexing")==0) return DofIndexingEnum;
@@ -260,8 +281,6 @@
 	      else if (strcmp(name,"IntInput")==0) return IntInputEnum;
 	      else if (strcmp(name,"IntParam")==0) return IntParamEnum;
-         else stage=3;
-   }
-   if(stage==3){
-	      if (strcmp(name,"IntVecParam")==0) return IntVecParamEnum;
+	      else if (strcmp(name,"IntVecParam")==0) return IntVecParamEnum;
+	      else if (strcmp(name,"TransientParam")==0) return TransientParamEnum;
 	      else if (strcmp(name,"MacAyeal2dIceFront")==0) return MacAyeal2dIceFrontEnum;
 	      else if (strcmp(name,"MacAyeal3dIceFront")==0) return MacAyeal3dIceFrontEnum;
@@ -365,5 +384,8 @@
 	      else if (strcmp(name,"IntMatParam")==0) return IntMatParamEnum;
 	      else if (strcmp(name,"RheologyBbarAbsGradient")==0) return RheologyBbarAbsGradientEnum;
-	      else if (strcmp(name,"DragCoefficientAbsGradient")==0) return DragCoefficientAbsGradientEnum;
+         else stage=4;
+   }
+   if(stage==4){
+	      if (strcmp(name,"DragCoefficientAbsGradient")==0) return DragCoefficientAbsGradientEnum;
 	      else if (strcmp(name,"TransientInput")==0) return TransientInputEnum;
 	      else if (strcmp(name,"Outputfilename")==0) return OutputfilenameEnum;
@@ -383,8 +405,6 @@
 	      else if (strcmp(name,"StressTensorzz")==0) return StressTensorzzEnum;
 	      else if (strcmp(name,"IceVolume")==0) return IceVolumeEnum;
-         else stage=4;
-   }
-   if(stage==4){
-	      if (strcmp(name,"P0")==0) return P0Enum;
+	      else if (strcmp(name,"TotalSmb")==0) return TotalSmbEnum;
+	      else if (strcmp(name,"P0")==0) return P0Enum;
 	      else if (strcmp(name,"P1")==0) return P1Enum;
 	      else if (strcmp(name,"P1DG")==0) return P1DGEnum;
@@ -468,4 +488,4 @@
    }
 	/*If we reach this point, the string provided has not been found*/
-   _error_("Enum %s not found",name);
+	_error2_("Enum " << name << " not found");
 }
Index: issm/branches/trunk-jpl-damage/src/c/modules/SurfaceAbsVelMisfitx/SurfaceAbsVelMisfitx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/SurfaceAbsVelMisfitx/SurfaceAbsVelMisfitx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/SurfaceAbsVelMisfitx/SurfaceAbsVelMisfitx.h	(revision 12878)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/SurfaceAreax/SurfaceAreax.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/SurfaceAreax/SurfaceAreax.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/SurfaceAreax/SurfaceAreax.cpp	(revision 12878)
@@ -11,5 +11,5 @@
 #include "../InputUpdateFromConstantx/InputUpdateFromConstantx.h"
 
-void SurfaceAreax( double* pS, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials,Parameters* parameters){
+void SurfaceAreax( IssmDouble* pS, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials,Parameters* parameters){
 	
 	/*Intermediary*/
@@ -18,6 +18,6 @@
 
 	/*output: */
-	double S=0;
-	double S_sum;
+	IssmDouble S=0;
+	IssmDouble S_sum;
 	
 	/*Compute gradients: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/SurfaceAreax/SurfaceAreax.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/SurfaceAreax/SurfaceAreax.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/SurfaceAreax/SurfaceAreax.h	(revision 12878)
@@ -6,9 +6,9 @@
 #define _SURFACEAREAX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../Container/Container.h"
 
 /* local prototypes: */
-void SurfaceAreax( double* pS, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters);
+void SurfaceAreax( IssmDouble* pS, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters);
 
 #endif  /* _SURFACEAREAX_H */
Index: issm/branches/trunk-jpl-damage/src/c/modules/SurfaceAverageVelMisfitx/SurfaceAverageVelMisfitx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/SurfaceAverageVelMisfitx/SurfaceAverageVelMisfitx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/SurfaceAverageVelMisfitx/SurfaceAverageVelMisfitx.h	(revision 12878)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
